package com.gemho.action;

import java.util.HashSet;
import java.util.Set;

import com.gemho.bean.TabRole;
import com.gemho.bean.TabUser;
import com.gemho.dao.RoleImpl;
import com.opensymphony.xwork2.ActionSupport;

public class updateUserAction extends ActionSupport {

	private static final long serialVersionUID = 1L;
	private RoleImpl roleDao;
	private String username;
	private String password;
	private String oldpassword;
	private String rolesel;
	private String id;
	public void setId(String id) {
		this.id = id;
	}
	public void setRoleDao(RoleImpl roleDao) {
		this.roleDao = roleDao;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public void setOldpassword(String oldpassword) {
		this.oldpassword = oldpassword;
	}
	public void setRolesel(String rolesel) {
		this.rolesel = rolesel;
	}
	@Override
	public String execute() throws Exception {
		TabUser user = roleDao.selectUser(Integer.parseInt(id));
		user.setUsername(username);
		user.setPassword(password);
		Set<TabRole> se = new HashSet<TabRole>();
		TabRole role =  roleDao.selectRole(Integer.parseInt(rolesel));
		se.add(role);
		user.setRoles(se);
		roleDao.updateUser(user);
		return SUCCESS;
	}
	@Override
	public void validate() {
		this.clearErrorsAndMessages();
		
		if(password.equals("") == true){
			this.addFieldError("password", "");
		}
		if(password.equals(oldpassword)== false){
			this.addFieldError("password", "벻һ");
		}
		
	}
	
	
}
