package com.gemho.dao;

import java.io.DataOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.transform.Transformers;
import org.springframework.orm.hibernate3.HibernateTemplate;
import com.gemho.bean.TabAlarmlog;
import com.gemho.bean.TabKushuiwei;
import com.gemho.bean.TabSensor;
import com.gemho.bean.value;
import com.gemho.bean.value2;
import com.gemho.daoIf.kushuiweiDao;
import com.gemho.util.HibernateUtil;

public class kushuiweiImpl implements kushuiweiDao {
	private HibernateTemplate ht;
	public HibernateTemplate getHt() {
		return ht;
	}
	public void setHt(HibernateTemplate ht) {
		this.ht = ht;
	}
	@SuppressWarnings("unchecked")
	public List getWeiZhi(String mark, String zduan) {
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List list = new ArrayList();
		try {
			String sql = "FROM TabSensor WHERE mark = '"+mark+"' order by name";
		    list = session.createQuery(sql).list();
			for (int i = 0; i < list.size(); i++) {
				String sensorname = ((TabSensor)list.get(i)).getName();
				String alarmvalue = ((TabSensor)list.get(i)).getAlarmvalue();
				if(alarmvalue.contains("|")){
					String[] sq = alarmvalue.split("\\|");
					((TabSensor)list.get(i)).setAlarmvalue1(sq[0]);
					((TabSensor)list.get(i)).setAlarmvalue2(sq[1]);
					if(sq.length>2){
						((TabSensor)list.get(i)).setAlarmvalue3(sq[2]);
					}
				}else{
					((TabSensor)list.get(i)).setAlarmvalue1(alarmvalue);
				}
				// PersonֶǱ֣Ȼ־ҪϸִСд
				Query query;
				String sqlStr="FROM TabKushuiwei WHERE sensorname = '"+sensorname+"' and id=(SELECT max(id) FROM TabKushuiwei WHERE sensorname = '"+sensorname+"' and ifview=1 and ifstart=0 group by sensorname)";
				query = session.createQuery(sqlStr);
				TabKushuiwei kushuiwei = (TabKushuiwei)query.uniqueResult();
				Double yvalue = null;
				Double yvalue1 = null;
				if(kushuiwei!=null){
					yvalue = kushuiwei.getValue2();
					yvalue1 = kushuiwei.getValue3();
				}
				((TabSensor)list.get(i)).setBzuobiao(yvalue+"");
				((TabSensor)list.get(i)).setCzuobiao(yvalue1+"");
			}
			//listAll.add(list);
			tx.commit();
		}catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return list;
	}
	@SuppressWarnings("unchecked")
	public List<Object> Search_Page_new_ls(String mark) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		String sql = "";
		List<Object> list = null;
		List listAll = new ArrayList();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			String a = "FROM TabSensor WHERE mark = '"+mark+"' order by name";
			list = session.createQuery(a).list();
			for (int i2 = 0; i2 < list.size(); i2++) {
				value value = new value ();
				TabSensor TabSensor2 = (TabSensor) list.get(i2);
				sql ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value2,ifbj,ifstart FROM tab_kushuiwei spwy where spwy.sensorname='"+TabSensor2.getName()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_kushuiwei where sensorname='"+TabSensor2.getName()+"' and ifview=1 ) - interval '7 day') and ifview=1  order by jctime";
				String sqll = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+TabSensor2.getName()+"') and ifzhengchang=2 and sensorname='"+TabSensor2.getName()+"'";
				query = session.createSQLQuery(sql).setResultTransformer(
						Transformers.ALIAS_TO_ENTITY_MAP);
				List list1 = (List<Object>) query.list();
				List list2 = session.createQuery(sqll).list();
				String ifguzhang = "0";
				if(list2.size()>0){
					ifguzhang = "1";
				}
				List listValue = new ArrayList();
				int id =0;
				for (int i = 0; i < list1.size(); i++) {
					value2 value2= new value2();
					Map map =(Map)list1.get(i);
					Date jctime =  sdf.parse((map.get("jctime").toString()));
					String  yvalue = map.get("value2").toString();
					String ifbj = map.get("ifbj").toString();
					String ifstart = map.get("ifstart").toString();
					if("1".equals(ifbj)){
						id = 1;
					}

					if("1".equals(ifstart)){
						yvalue = null;
					}

					value2.setJctime(jctime.getTime()+"");
					value2.setValue1(yvalue);
					listValue.add(value2);
				}
				String alarms = TabSensor2.getAlarmvalue();
				if(alarms.contains("|")){
					String[] sq = alarms.split("\\|");
					value.setAlarm1(sq[0]);
					value.setAlarm2(sq[1]);
					if(sq.length>2){
						value.setAlarm3(sq[2]);
					}
				}else{
					value.setAlarm1(alarms);
				}
				value.setData(listValue);
				value.setIfbj(id+"");
				value.setIfguzhang(ifguzhang);
				value.setName(TabSensor2.getName());
				listAll.add(value);
			}

			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return listAll;
	}
	private int portto ;
	private String ip;

	/**
	 * @author Administrator
	 * @param 
	 *            ,û,ԭ //
	 */
	public int logstopalarm(String sensorname, String username, String reason) {
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		int oi = 0;
		Calendar calendat = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String dateStr = sdf.format(calendat.getTime());
		Timestamp ts = Timestamp.valueOf(dateStr);
		try {
			TabAlarmlog work2 = new TabAlarmlog();
			work2.setSensorname(sensorname);
			work2.setUsername(username);
			work2.setReason(reason);
			work2.setJiechutime(ts);
			work2.setKind("ˮλ");
			ht.save(work2);
			// ±״̬
			Query query;
			if(sensorname.contains("*")){
				String[] name = sensorname.split("\\*");
				for (int i = 0; i < name.length; i++) {
					query = (Query) session
					.createQuery( "update  TabKushuiwei user2 set user2.ifbj ='0' ,user2.jcbjtime = '"+ ts+ "' where sensorname = '"+ name[i]+ "' and ifbj ='1' ");
					((org.hibernate.Query) query).executeUpdate();
				}
			}else{
				query = (Query) session
				.createQuery( "update  TabKushuiwei user2 set user2.ifbj ='0' ,user2.jcbjtime = '"+ ts+ "' where sensorname = '"+ sensorname+ "' and ifbj ='1' ");
				((org.hibernate.Query) query).executeUpdate();
			}

			query = session.createQuery("FROM TabKushuiwei WHERE ifbj ='1'");
			if(query.list()==null||query.list().size()<=0){
				query = (Query) session
				.createQuery( "delete  from TabAlarmtype where alarmtype = 'ˮλ'");
				((org.hibernate.Query) query).executeUpdate();
			}
			tx.commit();
			try {
				daohanglanImpl dhl = new daohanglanImpl();
				ip = dhl.getProperties("ip");
				portto = Integer.parseInt(dhl.getProperties("portto"));
				Socket socket = new Socket(ip, portto);
				OutputStream outputStream = socket.getOutputStream();
				String strFileName = "alarm" + sensorname;
				DataOutputStream outStream = new DataOutputStream(outputStream);
				byte[] bs = strFileName.getBytes("UTF-8");
				outStream.write(bs, 0, bs.length);
				Thread.sleep(1000);
				outStream.flush();
				outStream.close();
				socket.close();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			oi = 1;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return oi;
	}

	@SuppressWarnings("unchecked")
	public List<Object> Search_XX_new(String sensorname, String firstTime,
			String lastTime) {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List listAll = new ArrayList();
		try{
			Query query;
			if(!firstTime.equals("1")||(!lastTime.equals("1"))){
				if(sensorname.contains("*")){
					String[] name  = sensorname.split("\\*");
					for (int i = 0; i < name.length; i++) {
						String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value2,ifstart  FROM tab_kushuiwei where sensorname='"+name[i]+"' and jctime between '"+firstTime+"' and '"+lastTime+"'  and ifview =1  order by jctime";
						query = session.createSQLQuery(jrxSql).setResultTransformer(
								Transformers.ALIAS_TO_ENTITY_MAP);
						List list =  query.list();
						List listValue = new ArrayList();
						value value = new value ();
						for (int i3 = 0; i3 < list.size(); i3++) {
							value2 value2= new value2();
							Map map =(Map)list.get(i3);
							Date jctime =  sdf.parse((map.get("jctime").toString()));
							String  ylvalue = map.get("value2").toString();
							String  ifstart = map.get("ifstart").toString();
							value2.setJctime(jctime.getTime()+"");
							//value2.setValue(ylvalue);
							if("1".equals(ifstart)){
								value2.setValue(null);
							}else{
								value2.setValue(ylvalue);
							}
							listValue.add(value2);
						}
						value.setData(listValue);
						value.setName(name[i]);
						listAll.add(value);
					}
				}else{
					String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value2,ifstart  FROM tab_kushuiwei where sensorname='"+sensorname+"' and jctime between '"+firstTime+"' and '"+lastTime+"'  and ifview =1  order by jctime";
					query = session.createSQLQuery(jrxSql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List list =  query.list();
					System.out.println(list.size());
					List listValue = new ArrayList();
					value value = new value ();
					for (int i3 = 0; i3 < list.size(); i3++) {
						value2 value2= new value2();
						Map map =(Map)list.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value2").toString();
						String  ifstart = map.get("ifstart").toString();
						value2.setJctime(jctime.getTime()+"");
						//value2.setValue(ylvalue);
						if("1".equals(ifstart)){
							value2.setValue(null);
						}else{
							value2.setValue(ylvalue);
						}
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setName(sensorname);
					listAll.add(value);
				}
			}
			else{
				if(sensorname.contains("*")){
					String[] name  = sensorname.split("\\*");
					for (int i = 0; i < name.length; i++) {
						String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value2,ifstart FROM tab_kushuiwei jrx where jrx.sensorname='"+name[i]+"' and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_shenliuliang where sensorname='"+name[i]+"' and ifview=1 ) - interval '7 day') and ifview=1   order by jctime";
						query = session.createSQLQuery(jrxSql).setResultTransformer(
								Transformers.ALIAS_TO_ENTITY_MAP);
						List list =  query.list();
						List listValue = new ArrayList();
						value value = new value ();
						for (int i3 = 0; i3 < list.size(); i3++) {
							value2 value2= new value2();
							Map map =(Map)list.get(i3);
							Date jctime =  sdf.parse((map.get("jctime").toString()));
							String  ylvalue = map.get("value2").toString();
							String  ifstart = map.get("ifstart").toString();
							value2.setJctime(jctime.getTime()+"");
							//value2.setValue(ylvalue);
							if("1".equals(ifstart)){
								value2.setValue(null);
							}else{
								value2.setValue(ylvalue);
							}
							listValue.add(value2);
						}
						value.setData(listValue);
						value.setName(name[i]);
						listAll.add(value);
					}
				}else{
					String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value2,ifstart FROM tab_kushuiwei jrx where jrx.sensorname='"+sensorname+"' and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_kushuiwei where sensorname='"+sensorname+"' and ifview=1 ) - interval '7 day') and ifview=1   order by jctime";
					query = session.createSQLQuery(jrxSql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List list =  query.list();
					List listValue = new ArrayList();
					value value = new value ();
					for (int i3 = 0; i3 < list.size(); i3++) {
						value2 value2= new value2();
						Map map =(Map)list.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value2").toString();
						String  ifstart = map.get("ifstart").toString();
						value2.setJctime(jctime.getTime()+"");
						//value2.setValue(ylvalue);
						if("1".equals(ifstart)){
							value2.setValue(null);
						}else{
							value2.setValue(ylvalue);
						}
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setName(sensorname);
					listAll.add(value);
				}
			}
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
			return listAll;
	}

	/**
	 * mark
	 * @return ״̬
	 */
	@SuppressWarnings("unchecked")
	public List<Object> Search_CGQ_new(String mark) {
		Session session = HibernateUtil.openSession();
		Transaction tr = session.beginTransaction();
		List list  = new ArrayList();
		try {
			String a = "SELECT name FROM TabSensor  WHERE mark='"+mark+"' order by name";
			List sensor = ht.find(a);
			for (int i = 0; i < sensor.size(); i++) {

				value value = new value();
				String b = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+sensor.get(i).toString()+"') and ifzhengchang=2 and sensorname='"+sensor.get(i).toString()+"'";
				String c ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,ifbj FROM tab_kushuiwei spwy where spwy.sensorname='"+sensor.get(i).toString()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_kushuiwei where sensorname='"+sensor.get(i).toString()+"' and ifview='1') - interval '7 day') and ifview='1' and ifbj='1' order by jctime";
				String ifbj="0";
				String ifguzhang = "0";
				List guzhanglist = session.createSQLQuery(c).list();
				List bjlist = ht.find(b);
				if(bjlist.size()>0){
					ifbj="1";
				}
				if(guzhanglist.size()>0){
					ifguzhang = "1";
				}
				value.setIfbj(ifbj);
				value.setIfguzhang(ifguzhang);
				value.setName(sensor.get(i).toString());
				list.add(value);
			}
			tr.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tr) {
				tr.rollback();
			}
		}finally{
			HibernateUtil.close(session);
		}
		return list;
	}



	public List<Object> Search_Page_new_lsPT(String mark) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		String sql = "";
		List<Object> list = null;
		List listAll = new ArrayList();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			String a = "FROM TabSensor WHERE mark = '"+mark+"' order by name";
			list = session.createQuery(a).list();
			for (int i2 = 0; i2 < list.size(); i2++) {
				value value = new value ();
				TabSensor TabSensor2 = (TabSensor) list.get(i2);
				sql ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value2,ifbj,ifstart FROM tab_kushuiwei spwy where spwy.sensorname='"+TabSensor2.getName()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_kushuiwei where sensorname='"+TabSensor2.getName()+"' and ifview=1 ) - interval '7 day') and ifview=1  order by jctime";
				String sqll = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+TabSensor2.getName()+"') and ifzhengchang=2 and sensorname='"+TabSensor2.getName()+"'";
				query = session.createSQLQuery(sql).setResultTransformer(
						Transformers.ALIAS_TO_ENTITY_MAP);
				List list1 = (List<Object>) query.list();
				List list2 = session.createQuery(sqll).list();
				String ifguzhang = "0";
				if(list2.size()>0){
					ifguzhang = "1";
				}
				List listValue = new ArrayList();
				int id =0;
				for (int i = 0; i < list1.size(); i++) {
					value2 value2= new value2();
					Map map =(Map)list1.get(i);
					Date jctime =  sdf.parse((map.get("jctime").toString()));
					String  yvalue = map.get("value2").toString();
					String ifbj = map.get("ifbj").toString();
					String ifstart = map.get("ifstart").toString();
					if("1".equals(ifbj)){
						id = 1;
					}

					if("1".equals(ifstart)){
						yvalue = null;
					}

					value2.setJctime(jctime.getTime()+"");
					value2.setValue1(yvalue);
					listValue.add(value2);
				}
				String alarms = TabSensor2.getAlarmvalue();
				if(alarms.contains("|")){
					String[] sq = alarms.split("\\|");
					value.setAlarm1(sq[0]);
					value.setAlarm2(sq[1]);
					if(sq.length>2){
						value.setAlarm3(sq[2]);
					}
				}else{
					value.setAlarm1(alarms);
				}
				value.setData(listValue);
				value.setIfbj(id+"");
				value.setIfguzhang(ifguzhang);
				value.setName(TabSensor2.getName());
				listAll.add(value);
			}

			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return listAll;
	}
}
