package com.gemho.util;

import java.io.*;
import java.lang.reflect.*;
import java.util.*;
import java.text.SimpleDateFormat;
import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.hssf.util.HSSFColor;

import com.gemho.bean.TabKushuiwei;

/**
 * ÿԴPOI3.0.2̬EXCELĵ תʱ뱣Ϣע
 * 
 * @author leno
 * @version v1.0
 * @param <T>
 *            Ӧ÷ͣһjavabean
 *            עΪ˼boolean͵xxxgetʽΪgetXxx(),isXxx()
 *            byte[]jpgʽͼƬ
 */
public class ExportExcel<T> {

    public  void exportExcel(List list, OutputStream out) {
        exportExcel("POIEXCELĵ", null, list, out, "yyyy-MM-dd");
    }

    public void exportExcel(String[] headers, List list,
            OutputStream out) {
        exportExcel("POIEXCELĵ", headers, list, out, "yyyy-MM-dd");
    }

    public void exportExcel(String[] headers, List list,
            OutputStream out, String pattern) {
        exportExcel("POIEXCELĵ", headers, list, out, pattern);
    }

    /**
     * һͨõķJAVAķƣԽJAVAвҷһEXCEL ʽָIO豸
     * 
     * @param title
     *            
     * @param headers
     *            
     * @param dataset
     *            Ҫʾݼ,һҪ÷javabeanĶ󡣴˷ֵ֧
     *            javabeanԵлͼString,Date,byte[](ͼƬ)
     * @param out
     *            豸󣬿ԽEXCELĵļ
     * @param pattern
     *            ʱݣ趨ʽĬΪ"yyy-MM-dd"
     */
    @SuppressWarnings("unchecked")
    public void exportExcel(String title, String[] headers,
    		List list, OutputStream out, String pattern) {
         SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // һ
        HSSFWorkbook workbook = new HSSFWorkbook();
        // һ
        HSSFSheet sheet = workbook.createSheet(title);
        // ñĬпΪ15ֽ
        sheet.setDefaultColumnWidth((short) 25);
        sheet.setDefaultRowHeight((short) 350);
        // һʽ
        HSSFCellStyle style = workbook.createCellStyle();
        // Щʽ
        style.setFillForegroundColor(HSSFColor.SKY_BLUE.index);
        style.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
        style.setBorderBottom(HSSFCellStyle.BORDER_THIN);
        style.setBorderLeft(HSSFCellStyle.BORDER_THIN);
        style.setBorderRight(HSSFCellStyle.BORDER_THIN);
        style.setBorderTop(HSSFCellStyle.BORDER_THIN);
        style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
        // һ
        HSSFFont font = workbook.createFont();
        font.setColor(HSSFColor.VIOLET.index);
        font.setFontHeightInPoints((short) 12);
        font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
        // Ӧõǰʽ
        style.setFont(font);
        // ɲһʽ
        HSSFCellStyle style2 = workbook.createCellStyle();
        style2.setFillForegroundColor(HSSFColor.LIGHT_YELLOW.index);
        style2.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
        style2.setBorderBottom(HSSFCellStyle.BORDER_THIN);
        style2.setBorderLeft(HSSFCellStyle.BORDER_THIN);
        style2.setBorderRight(HSSFCellStyle.BORDER_THIN);
        style2.setBorderTop(HSSFCellStyle.BORDER_THIN);
        style2.setAlignment(HSSFCellStyle.ALIGN_CENTER);
        style2.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
        // һ
        HSSFFont font2 = workbook.createFont();
        font2.setBoldweight(HSSFFont.BOLDWEIGHT_NORMAL);
        // Ӧõǰʽ
        style2.setFont(font2);

        // һͼĶ
        HSSFPatriarch patriarch = sheet.createDrawingPatriarch();
        // ע͵ĴСλ,ĵ
        HSSFComment comment = patriarch.createComment(new HSSFClientAnchor(0,
                0, 0, 0, (short) 4, 2, (short) 6, 5));
        // ע
        comment.setString(new HSSFRichTextString("POIעͣ"));
        // עߣƶԪǿ״̬п.
        comment.setAuthor("leno");

        // 
        HSSFRow row = sheet.createRow(0);
        for (short i = 0; i < headers.length; i++) {
            HSSFCell cell = row.createCell(i);
            cell.setCellStyle(style);
            HSSFRichTextString text = new HSSFRichTextString(headers[i]);
            cell.setCellValue(text);
        }

        // ݣ
        Iterator<T> it = list.iterator();
        int index = 0;
        while (it.hasNext()) {
            index++;
            row = sheet.createRow(index);
            TabKushuiwei t = (TabKushuiwei) it.next();
            List<String> lt = new ArrayList<String>();
            String sensorname = t.getSensorname();
            lt.add(sensorname);
            Date jctime = t.getJctime();
            String jt = sdf.format(jctime);
            lt.add(jt);
            Date jcbjtime = t.getJcbjtime();
            String jbt = sdf.format(jcbjtime);
            lt.add(jbt);
            String ifbj  = "";
            String ib = t.getIfbj();
            if(ib=="1"||!jt.equals(jbt)){
            	ifbj = "";
            }
            lt.add(ifbj);
            lt.add(t.getValue2().toString());
            lt.add(t.getValue3().toString());
        //    Field[] fields = t.getClass().getDeclaredFields();
            
            for (short i = 0; i < lt.size(); i++) {
                HSSFCell cell = row.createCell(i);
                cell.setCellStyle(style2);
                String field = lt.get(i);
                cell.setCellValue(field);
             /*   String fieldName = field.getName();
                String getMethodName = "get"
                        + fieldName.substring(0, 1).toUpperCase()
                        + fieldName.substring(1);
                try {
                    Class tCls = t.getClass();
                    Method getMethod = tCls.getMethod(getMethodName,
                            new Class[] {});
                    Object value = getMethod.invoke(t, new Object[] {});
                    
                    // жֵͺǿת
                    String textValue = null;
                    if (value instanceof Boolean) {
                        boolean bValue = (Boolean) value;
                        textValue = "";
                        if (!bValue) {
                            textValue = "Ů";
                        }
                    } else if (value instanceof Date) {
                        Date date = (Date) value;
                        SimpleDateFormat sdf = new SimpleDateFormat(pattern);
                        textValue = sdf.format(date);
                    } else if (value instanceof byte[]) {
                        // ͼƬʱиΪ60px;
                        row.setHeightInPoints(60);
                        // ͼƬпΪ80px,עﵥλһ
                        sheet.setColumnWidth(i, (short) (35.7 * 80));
                        // sheet.autoSizeColumn(i);
                        byte[] bsValue = (byte[]) value;
                        HSSFClientAnchor anchor = new HSSFClientAnchor(0, 0,
                                1023, 255, (short) 6, index, (short) 6, index);
                        anchor.setAnchorType(2);
                        patriarch.createPicture(anchor, workbook.addPicture(
                                bsValue, HSSFWorkbook.PICTURE_TYPE_JPEG));
                    } else {
                        // Ͷַ򵥴
                        textValue = value.toString();
                    }
                    
                } catch (SecurityException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                } catch (NoSuchMethodException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                } catch (IllegalArgumentException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                } finally {
                    // Դ
                }*/
            }

        }
        try {
            workbook.write(out);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    }
