package com.gemho.util;

import com.gemho.bean.TabUser;
import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.MethodFilterInterceptor;

public class LoginInterceptor extends MethodFilterInterceptor {

	@Override
	protected String doIntercept(ActionInvocation invocation) throws Exception {
		String method = invocation.getProxy().getMethod();
		TabUser emp = (TabUser)invocation.getInvocationContext().getSession().get("loginEmp");
		if(emp==null){
			return "noLogin";
		}else{
			return invocation.invoke();
		}
	}
	
}
