package com.gemho.action;

import java.io.OutputStream;

import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.ServletActionContext;

import com.gemho.dao.HistoryImpl;
import com.opensymphony.xwork2.ActionSupport;

public class ShenliuliangExcelAction extends ActionSupport {

	private static final long serialVersionUID = 1L;
	private HistoryImpl historyDao;
	private String currentpage;
	private String pagesize;
	
   
	public String getCurrentpage() {
		return currentpage;
	}

	public void setCurrentpage(String currentpage) {
		this.currentpage = currentpage;
	}

	public String getPagesize() {
		return pagesize;
	}

	public void setPagesize(String pagesize) {
		this.pagesize = pagesize;
	}

	public void setHistoryDao(HistoryImpl historyDao) {
		this.historyDao = historyDao;
	}


	@Override
	public String execute() throws Exception {
		Integer cp = Integer.parseInt(currentpage);	
		Integer ps = Integer.parseInt(pagesize);
		int start = (cp-1)*ps;
		String sql = ServletActionContext.getRequest().getSession().getAttribute("ShenliuliangHistory")+"";	
		HttpServletResponse response = ServletActionContext.getResponse();
		response.setContentType("octets/stream");
        response.addHeader("Content-Disposition",
                "attachment;filename=shenliuliang.xls");
        OutputStream out = response.getOutputStream();
		historyDao.Search_excel(sql,start,ps,out);
        out.flush();
		return SUCCESS;
	}
	
}
