package com.gemho.action;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.struts2.ServletActionContext;

import com.gemho.bean.TabUser;
import com.gemho.dao.MessageImpl;
import com.opensymphony.xwork2.ActionSupport;

public class UpdateMessage1Action extends ActionSupport {
	private MessageImpl messageDao;

	public void setMessageDao(MessageImpl messageDao) {
		this.messageDao = messageDao;
	}
	private String haoma;
	private String neirong;
	private String shifoufasong;
	private String id;
	public void setId(String id) {
		this.id = id;
	}
	public void setHaoma(String haoma) {
		this.haoma = haoma;
	}
	public void setNeirong(String neirong) {
		this.neirong = neirong;
	}
	public void setShifoufasong(String shifoufasong) {
		this.shifoufasong = shifoufasong;
	}
	@Override
	public String execute() throws Exception {
		TabUser user = (TabUser)ServletActionContext.getRequest().getSession().getAttribute("loginEmp");
		//System.out.println(user);
		//messageDao.AddMessage(Integer.parseInt(shifoufasong), haoma, user.getUsername(), neirong);
		messageDao.updateMessage(Integer.parseInt(id), Integer.parseInt(shifoufasong), haoma, user.getUsername(), neirong);
		return SUCCESS;
	}
	@Override
	public void validate() {
		this.clearErrorsAndMessages();
		if(!haoma.equals("")){
			if(haoma.contains("") == true){
				String[] str1 = haoma.split("");
				
				haoma = "";
				for(int j = 0 ; j<str1.length ; j++){
					if(j>0){
						haoma += ",";
					}
					haoma += str1[j];
					
				}
			}
			String[] str = haoma.split(",");
			int count = 0;//count == 0 ûд   ==1 д  
			for(int m = 0 ;m< str.length ; m++){
				boolean ifhege = regex(str[m]);
				if(ifhege == false){
					count ++;
				}
			}
			if(count != 0){
				this.addFieldError("haoma","󣬻öŷָ");
			}
		}else{
			haoma = null;
		}
		//System.out.println(neirong);
		if(neirong == null ){
			this.addFieldError("neirong","ݲΪա");
		}
		if("2".equals(shifoufasong)){
			this.addFieldError("shifoufasong","Ƿûѡ");
		}
		super.validate();
	}
	public boolean regex(String haoma){
		String format = "^[1][3-8]\\d{9}$";
		Pattern p = Pattern.compile(format);
		Matcher m = p.matcher(haoma);
		boolean flat = m.matches();
		return flat;
	}
}
