package com.gemho.dao;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.transform.Transformers;
import org.springframework.orm.hibernate3.HibernateTemplate;
import com.gemho.bean.TabAlarmlog;
import com.gemho.bean.TabAnpoweiyi;
import com.gemho.bean.TabSensor;
import com.gemho.bean.value;
import com.gemho.bean.value2;
import com.gemho.util.HibernateUtil;

public class AnpoweiyiImpl {
	private HibernateTemplate ht;
	
    public HibernateTemplate getHt() {
		return ht;
	}

	public void setHt(HibernateTemplate ht) {
		this.ht = ht;
	}

	public List<Object> getWeizhi(String mark){ 
		Session session = HibernateUtil.openSession();
	    List<Object> listAll = new ArrayList<Object>();
		List<?> list= null;
		List<?> list1= null;
		String sql = "SELECT zkbh FROM TabSensor WHERE mark = '"+mark+"' and state='0' group by zkbh order by zkbh";
		try {
			list =session.createQuery(sql).list() ;
			for (int i = 0; i < list.size(); i++) {
				String zkbh = list.get(i).toString();
				List<?> listname = session.createQuery("FROM TabSensor WHERE mark = '"+mark+"'and zkbh ='"+zkbh+"'order by name").list(); 
				String x = null,y = null; 
				for (int j = 0; j < listname.size(); j++) {
					TabSensor tabSensor = ((TabSensor)listname.get(j));
					String sensorname = tabSensor.getName();
					String address2 = tabSensor.getAddress2();
					if(sensorname!=null){
						if(address2!= null && address2.contains("|")){
							//x|y ȡ֮ͼλ
							x = address2.split("\\|")[0];
							y = address2.split("\\|")[1];
							//ısensor ֵ 
							tabSensor.setAddress2(x);//λx
							tabSensor.setNotalarmvalue(y);//ʼλ
						}
					}
					list1 = session.createQuery("FROM TabAnpoweiyi where sensorname = '" + sensorname+ "' and jctime = (SELECT max(jctime) FROM TabAnpoweiyi where ifview =1 and ifstart = 0 and sensorname = '" + sensorname+ "' )").list();
					//ѯһ¼ жλ
					if(list1.size()>0){
						TabAnpoweiyi nbcj = (TabAnpoweiyi)list1.get(0);
						double value = nbcj.getValue2();
						//λ x,y(h)ʼ-仯value
						double h = Double.parseDouble(x)+ value;
						//ısensor 1ֵ 
						//sensor.setBzuobiao(x);//λx
						tabSensor.setKind(h+"");//λ
					}else{
						//sensor.setBzuobiao(x);//λx
						tabSensor.setKind(x);//λ
					}
				}
				listAll.add(listname);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return listAll;
  }
	public List<Object> getWeizhiFB(String mark){ 
		Session session = HibernateUtil.openSession();
	    List<Object> listAll = new ArrayList<Object>();
		List<?> list= null;
		List<?> list1= null;
		String sql = "SELECT zkbh FROM TabSensor WHERE mark = '"+mark+"' and state='FB' group by zkbh order by zkbh";
		try {
			list =session.createQuery(sql).list() ;
			for (int i = 0; i < list.size(); i++) {
				String zkbh = list.get(i).toString();
				List<?> listname = session.createQuery("FROM TabSensor WHERE mark = '"+mark+"'and zkbh ='"+zkbh+"'order by name").list(); 
				String x = null,y = null; 
				for (int j = 0; j < listname.size(); j++) {
					TabSensor tabSensor = ((TabSensor)listname.get(j));
					String sensorname = tabSensor.getName();
					String address2 = tabSensor.getAddress2();
					if(sensorname!=null){
						if(address2!= null && address2.contains("|")){
							//x|y ȡ֮ͼλ
							x = address2.split("\\|")[0];
							y = address2.split("\\|")[1];
							//ısensor ֵ 
							tabSensor.setAddress2(x);//λx
							tabSensor.setNotalarmvalue(y);//ʼλ
						}
					}
					list1 = session.createQuery("FROM TabAnpoweiyi where sensorname = '" + sensorname+ "' and jctime = (SELECT max(jctime) FROM TabAnpoweiyi where ifview =1 and ifstart = 0 and sensorname = '" + sensorname+ "' )").list();
					//ѯһ¼ жλ
					if(list1.size()>0){
						TabAnpoweiyi nbcj = (TabAnpoweiyi)list1.get(0);
						double value = nbcj.getValue2();
						//λ x,y(h)ʼ-仯value
						double h = Double.parseDouble(x)+ value;
						//ısensor 1ֵ 
						//sensor.setBzuobiao(x);//λx
						tabSensor.setKind(h+"");//λ
					}else{
						//sensor.setBzuobiao(x);//λx
						tabSensor.setKind(x);//λ
					}
				}
				listAll.add(listname);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return listAll;
  }
	
	public List<Object> Search_Page_new_ls(String mark) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:MM:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		String sq = "";
		List<Object> listAll = new ArrayList<Object>();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			String a = "SELECT zkbh FROM TabSensor WHERE mark = '"+mark+"' and state='0' group by zkbh order by zkbh";
			List<?> zkbh = session.createQuery(a).list();
			for (int i = 0; i < zkbh.size(); i++) {
				String b = "FROM TabSensor WHERE zkbh = '"+zkbh.get(i).toString()+"' and mark = '"+mark+"' order by name";
				List<?> sensorname = session.createQuery(b).list();
				List<value> listzk = new ArrayList<value>();
				for (int i2 = 0; i2 < sensorname.size(); i2++) {
					value value = new value ();
					TabSensor TabSensor2 = (TabSensor) sensorname.get(i2);
					sq = "SELECT  to_char(jctime,'yyyy-mm-dd hh24:mm:ss') as jctime, value2, value3, ifstart, ifbj FROM tab_anpoweiyi WHERE "+
					 " id in (SELECT max(id) FROM  tab_anpoweiyi WHERE  sensorname = '"+TabSensor2.getName()+"' group by to_char(jctime,'yyyy-mm-dd') ORDER BY to_char(jctime,'yyyy-mm-dd') DESC) and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_anpoweiyi where sensorname='"+TabSensor2.getName()+"' and ifview=1 ) - interval '7 day') and"+
					 " ifview = 1 ORDER BY jctime ;";

					String sqll = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+TabSensor2.getName()+"') and ifzhengchang=2 and sensorname='"+TabSensor2.getName()+"'"; 
					query = session.createSQLQuery(sq).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List<?> list1 = query.list();
					List<?> list2 = session.createQuery(sqll).list();
					String ifguzhang = "0";
					if(list2.size()>0){
						ifguzhang = "1";
					}
					List<value2> listValue = new ArrayList<value2>();
					int id =0;
					for (int i3 = 0; i3 < list1.size(); i3++) {
						value2 value2= new value2();
						Map<?, ?> map =(Map<?, ?>)list1.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value3").toString();
						String ifbj = map.get("ifbj").toString();
						String ifstart = map.get("ifstart").toString();
						if("1".equals(ifbj)){
							id = 1;
						}
						 
						if("1".equals(ifstart)){
							ylvalue = null;
						}
						value2.setJctime(jctime.getTime()+"");
						value2.setValue(ylvalue);
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setIfbj(id+"");
					value.setIfguzhang(ifguzhang);
					value.setName(TabSensor2.getName());
					String alarm = TabSensor2.getAlarmvalue().toString();
					if(alarm.contains("|")){
					String[] alarms = alarm.split("\\|");
					value.setAlarm1(alarms[0]);
					value.setAlarm2(alarms[1]);
					if(alarms.length>2){
						value.setAlarm3(alarms[2]);
					}
					}else{
						value.setAlarm1(alarm);
					}
					listzk.add(value);
				}
				listAll.add(listzk);
			}
			
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return listAll;
	}
	
	public List<Object> Search_Page_new_lsFB(String mark) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:MM:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		String sq = "";
		List<Object> listAll = new ArrayList<Object>();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			String a = "SELECT zkbh FROM TabSensor WHERE mark = '"+mark+"' and state='FB' group by zkbh order by zkbh";
			List<?> zkbh = session.createQuery(a).list();
			for (int i = 0; i < zkbh.size(); i++) {
				String b = "FROM TabSensor WHERE zkbh = '"+zkbh.get(i).toString()+"' and mark = '"+mark+"' order by name";
				List<?> sensorname = session.createQuery(b).list();
				List<value> listzk = new ArrayList<value>();
				for (int i2 = 0; i2 < sensorname.size(); i2++) {
					value value = new value ();
					TabSensor TabSensor2 = (TabSensor) sensorname.get(i2);
					sq = "SELECT  to_char(jctime,'yyyy-mm-dd hh24:mm:ss') as jctime, value2, value3, ifstart, ifbj FROM tab_anpoweiyi WHERE "+
					 " id in (SELECT max(id) FROM  tab_anpoweiyi WHERE  sensorname = '"+TabSensor2.getName()+"' group by to_char(jctime,'yyyy-mm-dd') ORDER BY to_char(jctime,'yyyy-mm-dd') DESC) and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_anpoweiyi where sensorname='"+TabSensor2.getName()+"' and ifview=1 ) - interval '7 day') and"+
					 " ifview = 1 ORDER BY jctime ;";

					String sqll = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+TabSensor2.getName()+"') and ifzhengchang=2 and sensorname='"+TabSensor2.getName()+"'"; 
					query = session.createSQLQuery(sq).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List<?> list1 = query.list();
					List<?> list2 = session.createQuery(sqll).list();
					String ifguzhang = "0";
					if(list2.size()>0){
						ifguzhang = "1";
					}
					List<value2> listValue = new ArrayList<value2>();
					int id =0;
					for (int i3 = 0; i3 < list1.size(); i3++) {
						value2 value2= new value2();
						Map<?, ?> map =(Map<?, ?>)list1.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value3").toString();
						String ifbj = map.get("ifbj").toString();
						String ifstart = map.get("ifstart").toString();
						if("1".equals(ifbj)){
							id = 1;
						}
						 
						if("1".equals(ifstart)){
							ylvalue = null;
						}
						value2.setJctime(jctime.getTime()+"");
						value2.setValue(ylvalue);
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setIfbj(id+"");
					value.setIfguzhang(ifguzhang);
					value.setName(TabSensor2.getName());
					String alarm = TabSensor2.getAlarmvalue().toString();
					if(alarm.contains("|")){
					String[] alarms = alarm.split("\\|");
					value.setAlarm1(alarms[0]);
					value.setAlarm2(alarms[1]);
					if(alarms.length>2){
						value.setAlarm3(alarms[2]);
					}
					}else{
						value.setAlarm1(alarm);
					}
					listzk.add(value);
				}
				listAll.add(listzk);
			}
			
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return listAll;
	}
	
	public int logstopalarm(String sensorname, String username, String reason) {
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		int oi = 0;
		Calendar calendat = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String dateStr = sdf.format(calendat.getTime());
		Timestamp ts = Timestamp.valueOf(dateStr);
		try {
			TabAlarmlog work2 = new TabAlarmlog();
			work2.setSensorname(sensorname);
			work2.setUsername(username);
			work2.setReason(reason);
			work2.setJiechutime(ts);
			work2.setKind("λ");
			ht.save(work2);
			// ±״̬
			Query query;
			if(sensorname.contains("*")){
				String[] name = sensorname.split("\\*");
				for (int i = 0; i < name.length; i++) {
					query = (Query) session
					.createQuery( "update  TabAnpoweiyi user2 set user2.ifbj ='0' ,user2.jcbjtime = '"+ ts+ "' where sensorname = '"+ name[i]+ "' and ifbj ='1' ");
					((org.hibernate.Query) query).executeUpdate();
				}
			}else{
				query = (Query) session
				.createQuery( "update  TabAnpoweiyi user2 set user2.ifbj ='0' ,user2.jcbjtime = '"+ ts+ "' where sensorname = '"+ sensorname+ "' and ifbj ='1' ");
				((org.hibernate.Query) query).executeUpdate();
			}
			
			query = session.createQuery("FROM TabAnpoweiyi WHERE ifbj ='1'");
			if(query.list()==null||query.list().size()<=0){
				query = (Query) session
				.createQuery( "delete  from TabAlarmtype where alarmtype = 'λ'");
				((org.hibernate.Query) query).executeUpdate();
			}
			tx.commit();
			oi = 1;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return oi;
	}
	
	public List<Object> Search_XX_new(String sensorname, String firstTime,
			String lastTime) {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:MM:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<Object> listAll = new ArrayList<Object>();
		try{
			Query query;
			if(!firstTime.equals("1")||(!lastTime.equals("1"))){
				if(sensorname.contains("*")){
					String[] name  = sensorname.split("\\*");
					for (int i = 0; i < name.length; i++) {
						String jrxSql = "SELECT  to_char(jctime,'yyyy-mm-dd HH24:mm:ss')as jctime,value3,ifstart FROM tab_anpoweiyi where sensorname='"+name[i]+"' and jctime between '"+firstTime+"' and '"+lastTime+"'  and ifview =1  order by jctime";
						query = session.createSQLQuery(jrxSql).setResultTransformer(
								Transformers.ALIAS_TO_ENTITY_MAP);
						List<?> list =  query.list();
						List<value2> listValue = new ArrayList<value2>();
						value value = new value ();
						for (int i3 = 0; i3 < list.size(); i3++) {
							value2 value2= new value2();
							Map<?, ?> map =(Map<?, ?>)list.get(i3);
							Date jctime =  sdf.parse((map.get("jctime").toString()));
							String  ylvalue = map.get("value3").toString();
							String  ifstart = map.get("ifstart").toString();
							value2.setJctime(jctime.getTime()+"");
							//value2.setValue(ylvalue);
							if("1".equals(ifstart)){
								value2.setValue(null);
							}else{
								value2.setValue(ylvalue);
							}
							listValue.add(value2);
						}
						value.setData(listValue);
						value.setName(name[i]);
						listAll.add(value);
					}
				}else{
					String jrxSql = "SELECT  to_char(jctime,'yyyy-mm-dd HH24:mm:ss')as jctime,value3,ifstart FROM tab_anpoweiyi where sensorname='"+sensorname+"' and jctime between '"+firstTime+"' and '"+lastTime+"'  and ifview =1  order by jctime";
					query = session.createSQLQuery(jrxSql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List<?> list =  query.list();
					List<value2> listValue = new ArrayList<value2>();
					value value = new value ();
					for (int i3 = 0; i3 < list.size(); i3++) {
						value2 value2= new value2();
						Map<?, ?> map =(Map<?, ?>)list.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value3").toString();
						String  ifstart = map.get("ifstart").toString();
						value2.setJctime(jctime.getTime()+"");
						//value2.setValue(ylvalue);
						if("1".equals(ifstart)){
							value2.setValue(null);
						}else{
							value2.setValue(ylvalue);
						}
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setName(sensorname);
					listAll.add(value);
				}
			}
			else{
				if(sensorname.contains("*")){
					String[] name  = sensorname.split("\\*");
					for (int i = 0; i < name.length; i++) {
						String jrxSql = "SELECT  to_char(jctime,'yyyy-mm-dd HH24:mm:ss')as jctime,value3,ifstart FROM tab_anpoweiyi jrx where jrx.sensorname='"+name[i]+"' and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_anpoweiyi where sensorname='"+name[i]+"' and ifview=1 ) - interval '7 day') and ifview=1   order by jctime";
						query = session.createSQLQuery(jrxSql).setResultTransformer(
								Transformers.ALIAS_TO_ENTITY_MAP);
						List<?> list =  query.list();
						List<value2> listValue = new ArrayList<value2>();
						value value = new value ();
						for (int i3 = 0; i3 < list.size(); i3++) {
							value2 value2= new value2();
							Map<?, ?> map =(Map<?, ?>)list.get(i3);
							Date jctime =  sdf.parse((map.get("jctime").toString()));
							String  ylvalue = map.get("value3").toString();
							String  ifstart = map.get("ifstart").toString();
							value2.setJctime(jctime.getTime()+"");
							//value2.setValue(ylvalue);
							if("1".equals(ifstart)){
								value2.setValue(null);
							}else{
								value2.setValue(ylvalue);
							}
							listValue.add(value2);
						}
						value.setData(listValue);
						value.setName(name[i]);
						listAll.add(value);
					}
				}else{
					String jrxSql = "SELECT  to_char(jctime,'yyyy-mm-dd HH24:mm:ss')as jctime,value3,ifstart FROM tab_anpoweiyi jrx where jrx.sensorname='"+sensorname+"' and jctime >=((select date(to_char(max(jctime),'yyyy-mm-dd ')) from tab_anpoweiyi where sensorname='"+sensorname+"' and ifview=1 ) - interval '7 day') and ifview=1   order by jctime";
					query = session.createSQLQuery(jrxSql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List<?> list =  query.list();
					List<value2> listValue = new ArrayList<value2>();
					value value = new value ();
					for (int i3 = 0; i3 < list.size(); i3++) {
						value2 value2= new value2();
						Map<?, ?> map =(Map<?, ?>)list.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value3").toString();
						String  ifstart = map.get("ifstart").toString();
						value2.setJctime(jctime.getTime()+"");
						//value2.setValue(ylvalue);
						if("1".equals(ifstart)){
							value2.setValue(null);
						}else{
							value2.setValue(ylvalue);
						}
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setName(sensorname);
					listAll.add(value);
				}
			}
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
			return listAll;
	}
	
	public List<Object> Search_CGQ_new(String mark) {
		Session session = HibernateUtil.openSession();
		Transaction tr = session.beginTransaction();
		List<Object> list  = new ArrayList<Object>();
		try {
			String a = "SELECT name FROM TabSensor  WHERE mark='"+mark+"' and state<>'FB' ";
			List<?> sensor = session.createQuery(a).list();
			for (int i = 0; i < sensor.size(); i++) {
				value value = new value();
				String b = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+sensor.get(i).toString()+"') and ifzhengchang=2 and sensorname='"+sensor.get(i).toString()+"'";
				String c ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mm:ss')as jctime,ifbj FROM tab_anpoweiyi spwy where spwy.sensorname='"+sensor.get(i).toString()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_anpoweiyi where sensorname='"+sensor.get(i).toString()+"' and ifview='1') - interval '7 day') and ifview='1' and ifbj='1' order by jctime";
				String ifguzhang="0";
				String ifbj = "0";
				List<?> guzhanglist = session.createQuery(b).list();
				List<?> bjlist = session.createSQLQuery(c).list();
				if(guzhanglist.size()>0){
					ifguzhang="1";	
				}
				if(bjlist.size()>0){
					ifbj = "1";
				}
				value.setIfbj(ifbj);
				value.setIfguzhang(ifguzhang);
				value.setName(sensor.get(i).toString());
				list.add(value);
			}
			tr.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tr) {
				tr.rollback();
			}
		}finally{
			HibernateUtil.close(session);
		}
		return list;
	}
	
	public List<Object> Search_CGQ_newFB(String mark) {
		Session session = HibernateUtil.openSession();
		Transaction tr = session.beginTransaction();
		List<Object> list  = new ArrayList<Object>();
		try {
			String a = "SELECT name FROM TabSensor  WHERE mark='"+mark+"' and state='FB' ";
			List<?> sensor = session.createQuery(a).list();
			for (int i = 0; i < sensor.size(); i++) {
				value value = new value();
				String b = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+sensor.get(i).toString()+"') and ifzhengchang=2 and sensorname='"+sensor.get(i).toString()+"'";
				String c ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mm:ss')as jctime,ifbj FROM tab_anpoweiyi spwy where spwy.sensorname='"+sensor.get(i).toString()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_anpoweiyi where sensorname='"+sensor.get(i).toString()+"' and ifview='1') - interval '7 day') and ifview='1' and ifbj='1' order by jctime";
				String ifguzhang="0";
				String ifbj = "0";
				List<?> guzhanglist = session.createQuery(b).list();
				List<?> bjlist = session.createSQLQuery(c).list();
				if(guzhanglist.size()>0){
					ifguzhang="1";	
				}
				if(bjlist.size()>0){
					ifbj = "1";
				}
				value.setIfbj(ifbj);
				value.setIfguzhang(ifguzhang);
				value.setName(sensor.get(i).toString());
				list.add(value);
			}
			tr.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tr) {
				tr.rollback();
			}
		}finally{
			HibernateUtil.close(session);
		}
		return list;
	}
}
