package com.gemho.dao;

import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFClientAnchor;
import org.apache.poi.hssf.usermodel.HSSFComment;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFPatriarch;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import com.gemho.bean.TabBatidibiaoweiyi;
import com.gemho.daoIf.HistoryDao;
import com.gemho.util.HibernateUtil;


public class batidibiaoweiyiHistoryImpl implements HistoryDao {

	public List<?> fenye(int onePageSize, int fromRecord, String bh, String mark) {
		List<?> al = null;
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if ("".equals(bh)||bh==null)
				query = session.createQuery(" from  "+mark+" object2 order by jctime desc");
			else
				query = session.createQuery(" from  "+mark+" object2 where "+bh+" order by jctime desc");

			query.setFirstResult(onePageSize);
			query.setMaxResults(fromRecord);
			al=query.list();
			return al;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}

	}
	//ÿҳҳ
	public  int page(String sql,String mark){
		Session session = HibernateUtil.openSession();
		Query query;
		if("".equals(sql)||sql==null){
			query = session.createQuery("select count(n.id) from "+mark+" n");
		}else{
			query = session.createQuery("select count(n.id) from "+mark+" n where "+sql+"");
		}
		if(query.uniqueResult()==null){
			return 0;
		}
		return (Integer)query.uniqueResult();
	}

	public List<?> getSensorname(String mark){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<?> list = null;
		try {
			Query query;
			query = session.createQuery("from TabSensor where mark='"+mark+"' order by id");
			//session.createSQLQuery("select name from Tab_sensor where mark="+mark).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			list = query.list();
			return list;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}
		
	}
	
	// execl
	static String[] title = {"", "ʱ", "ʱ",
		"Ƿ񱨾","x仯","y仯"};


	public String Search_excel(String where1,int start,int ps,OutputStream out) {
		String s_result = "test";
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<?> list = null;
		
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if ("".equals(where1))
				query = (Query) session
						.createQuery(" from  TabBatidibiaoweiyi where ifstart = '0' and ifview = '1'  order by jctime desc,sensorname");
			else {
				query = (Query) session
						.createQuery(" from  TabBatidibiaoweiyi object2  where "+where1+" and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
			}
			query.setFirstResult(start);
			query.setMaxResults(ps);
			list = query.list();
			//s_result = createExcel(list);
		//	OutputStream out = new FileOutputStream("E://a.xls");
			exportExcel("رˮƽλʷ",title,list, out);
			out.flush();
	      
			tx.commit();
		} catch (Exception ex) {
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return s_result;
	}
	
	public String Search_excel1(String where1,int start,int ps,OutputStream out) {
		String s_result = "test";
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<?> list = null;
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if ("".equals(where1))
				query = (Query) session
						.createQuery(" from  TabBatidibiaoweiyi where ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
			else {
				query = (Query) session
						.createQuery(" from  TabBatidibiaoweiyi object2  where "+where1+" and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
			}
			query.setFirstResult(start);
			query.setMaxResults(ps);
			list = query.list();
		//	s_result = createExcel(list);
			exportExcel("رˮƽλƱ¼",title,list, out);
			out.flush();
			tx.commit();
		} catch (Exception ex) {
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return s_result;
	}

    @SuppressWarnings("deprecation")
	public void exportExcel(String title, String[] headers,
    		List<?> list, OutputStream out) {
         SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // һ
        HSSFWorkbook workbook = new HSSFWorkbook();
        // һ
        HSSFSheet sheet = workbook.createSheet(title);
        // ñĬпΪ15ֽ
        sheet.setDefaultColumnWidth((short) 25);
        sheet.setDefaultRowHeight((short) 350);
        // һʽ
        HSSFCellStyle style = workbook.createCellStyle();
        // Щʽ
        style.setFillForegroundColor(HSSFColor.SKY_BLUE.index);
        style.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
        style.setBorderBottom(HSSFCellStyle.BORDER_THIN);
        style.setBorderLeft(HSSFCellStyle.BORDER_THIN);
        style.setBorderRight(HSSFCellStyle.BORDER_THIN);
        style.setBorderTop(HSSFCellStyle.BORDER_THIN);
        style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
        // һ
        HSSFFont font = workbook.createFont();
        font.setColor(HSSFColor.VIOLET.index);
        font.setFontHeightInPoints((short) 12);
        font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
        // Ӧõǰʽ
        style.setFont(font);
        // ɲһʽ
        HSSFCellStyle style2 = workbook.createCellStyle();
        style2.setFillForegroundColor(HSSFColor.LIGHT_YELLOW.index);
        style2.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
        style2.setBorderBottom(HSSFCellStyle.BORDER_THIN);
        style2.setBorderLeft(HSSFCellStyle.BORDER_THIN);
        style2.setBorderRight(HSSFCellStyle.BORDER_THIN);
        style2.setBorderTop(HSSFCellStyle.BORDER_THIN);
        style2.setAlignment(HSSFCellStyle.ALIGN_CENTER);
        style2.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
        // һ
        HSSFFont font2 = workbook.createFont();
        font2.setBoldweight(HSSFFont.BOLDWEIGHT_NORMAL);
        // Ӧõǰʽ
        style2.setFont(font2);

        // һͼĶ
        HSSFPatriarch patriarch = sheet.createDrawingPatriarch();
        // ע͵ĴСλ,ĵ
        HSSFComment comment = patriarch.createComment(new HSSFClientAnchor(0,
                0, 0, 0, (short) 4, 2, (short) 6, 5));
        // ע
        comment.setString(new HSSFRichTextString("β"));
        // עߣƶԪǿ״̬п.
        comment.setAuthor("С");

        // 
        HSSFRow row = sheet.createRow(0);
        for (short i = 0; i < headers.length; i++) {
            HSSFCell cell = row.createCell(i);
            cell.setCellStyle(style);
            HSSFRichTextString text = new HSSFRichTextString(headers[i]);
            cell.setCellValue(text);
        }

        // ݣ
        Iterator<?> it = list.iterator();
        int index = 0;
        while (it.hasNext()) {
            index++;
            row = sheet.createRow(index);
            TabBatidibiaoweiyi t = (TabBatidibiaoweiyi)it.next();
            List<String> lt = new ArrayList<String>();
            String sensorname = t.getSensorname();
            lt.add(sensorname);
            Date jctime = t.getJctime();
            String jt = sdf.format(jctime);
            lt.add(jt);
            Date jcbjtime = t.getJcbjtime();
            String jbt = sdf.format(jcbjtime);
            lt.add(jbt);
            String ifbj  = "";
            String ib = t.getIfbj().toString();
            if("1".equals(ib)||!jt.equals(jbt)){
            	ifbj = "";
            }
            lt.add(ifbj);
            lt.add(t.getDisx().toString());
            lt.add(t.getDisy().toString());
        //    Field[] fields = t.getClass().getDeclaredFields();
            for (short i = 0; i < lt.size(); i++) {
                HSSFCell cell = row.createCell(i);
                cell.setCellStyle(style2);
                String field = lt.get(i);
                cell.setCellValue(field);
             
            }

        }
        try {
            workbook.write(out);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }


}
